--[[		CounterCraft
]]--		   by Lolzen

--	Config:
local size = 22
local Anchor = "TOP"
local xOffSet = 0
local yOffSet = 0
--	Config END!

local KillFrame = CreateFrame("MessageFrame", nil, UIParent)
KillFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
KillFrame:SetTimeVisible(8)
KillFrame:SetInsertMode("BOTTOM")
KillFrame:SetFrameStrata("HIGH")
KillFrame:SetHeight(size * 3.2)
KillFrame:SetWidth(512)
KillFrame:SetPoint(Anchor, UIParent, xOffSet, yOffSet)
KillFrame:SetFont("Fonts\\FRIZQT__.TTF", size, "THINOUTLINE")
KillFrame:Show()

local function getClassColor(unit)
	local classcolor = RAID_CLASS_COLORS[select(2, UnitClass(unit))]
	return classcolor.r, classcolor.g, classcolor.b
end

local function getReactionColorName(name, flag)
	local rcname
	if flag and CombatLog_Object_IsA(flag, COMBATLOG_FILTER_HOSTILE_UNITS) then
		rcname = "|cffff0000"..name.."|r"
	elseif flag and CombatLog_Object_IsA(flag, COMBATLOG_FILTER_NEUTRAL_UNITS) then
		rcname = "|cffffff00"..name.."|r"
	elseif flag and CombatLog_Object_IsA(flag, COMBATLOG_FILTER_FRIENDLY_UNITS) then
		rcname = "|cff00ff00"..name.."|r"
	end
	return rcname
end

-- return hex value of color values and the unitname
local function getColorHexUnit(unit, r, g, b)
	return ("|cff%.2x%.2x%.2x%s|r"):format(r*255,g*255,b*255, UnitName(unit))
end

local function showMessage(src, srcFlag, dst, dstFlag, icon)
	local nameone, nametwo
	-- filter ot training dummys
	if dst == "(.-) Dummy" then return end
	-- get the first & second name in class/reaction color
	if UnitIsPlayer(src) then
		nameone = getColorHexUnit(src, getClassColor(src))
	else
		nameone = getReactionColorName(src, srcFlag)
	end
	if UnitIsPlayer(dst) then
		nametwo = getColorHexUnit(dst, getClassColor(dst))
	else
		nametwo = getReactionColorName(dst, dstFlag)
	end
	-- show the message
	if nameone == nil or nametwo == nil then return end
	KillFrame:AddMessage(nameone.." "..(string.format("|T%s:%d:%d:0:-1|t", icon, (size * 0.8), (size * 0.8))).." "..nametwo, 1.0, 1.0, 1.0)
end

function KillFrame.COMBAT_LOG_EVENT_UNFILTERED(self, event, ...)
	local timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = CombatLogGetCurrentEventInfo()
	if string.find(eventType, "_DAMAGE") then
		if string.find(eventType, "SWING") then 
			local overkill = select(13, CombatLogGetCurrentEventInfo())
			if overkill and overkill > 0 then
				-- let's get our actual mainhand Weapon
				local icon
				if UnitIsPlayer(sourceName) then
					icon = GetInventoryItemTexture(sourceName, GetInventorySlotInfo("MainHandSlot"))
				else
					icon = select(10, GetItemInfo(25))
				end
				showMessage(sourceName, sourceFlags, destName, destFlags, icon)
			end
		elseif string.find(eventType, "SPELL" or "RANGE") then
			local spell, _, _, _, overkill = select(12, CombatLogGetCurrentEventInfo())
			if overkill and overkill > 0 then
				local icon = select(3, GetSpellInfo(spell))
				showMessage(sourceName, sourceFlags, destName, destFlags, icon)
			end
		end
	end
end

KillFrame:SetScript("OnEvent", function(self, event, ...)  
	if(self[event]) then
		self[event](self, event, ...)
	else
		print(event)
	end 
end)